require({cache:{
'url:epi-ecf-ui/widget/templates/CatalogContentList.html':"﻿<div class=\"epi-catalogContentList\">\r\n    <div data-dojo-attach-point=\"toolbar\" data-dojo-type=\"epi-cms/contentediting/StandardToolbar\" class=\"epi-viewHeaderContainer epi-localToolbar\"></div>\r\n    <div class=\"epi-localToolbar epi-flatToolbar\">\r\n        <div class=\"epi-toolbarGroupContainer\">\r\n            <div class=\"epi-toolbarGroup epi-toolbarLeading\" data-dojo-attach-point=\"leadingNode\"></div>\r\n            <div class=\"epi-toolbarGroup epi-toolbarCenter\" data-dojo-attach-point=\"centerNode\"></div>\r\n            <div class=\"epi-toolbarGroup epi-toolbarTrailing\" data-dojo-attach-point=\"trailingNode\">\r\n                <ul data-dojo-attach-point=\"trailingGroupButton\">\r\n                    <li class=\"epi-trailingCommand\">\r\n                        <div>\r\n                            <label for=\"markets\">${resources.market}</label>\r\n                            <select name=\"markets\" data-dojo-type=\"epi-ecf-ui/widget/MarketSelector\" data-dojo-attach-point=\"marketSelector\" data-dojo-attach-event='onChange: _onMarketChanged' class=\"epi-chromelessSelect epi-flatSelect\"></select>\r\n                        </div>\r\n                    </li>\r\n                    <li class=\"epi-trailingCommand\">\r\n                        <span data-dojo-type=\"epi-ecf-ui/widget/CommandButton\" data-dojo-attach-point=\"listview\" data-dojo-attach-event='onClick: _onSwitchListView' class=\"epi-flatButton epi-chromelessButton\"\r\n                                data-dojo-props=\"iconClass: 'epi-iconList', showLabel: false, title: '${resources.switchbuttons.listview}'\">\r\n                        </span>\r\n                        <span data-dojo-type=\"epi-ecf-ui/widget/CommandButton\" data-dojo-attach-point=\"thumbnail\" data-dojo-attach-event='onClick: _onSwitchThumbnail' class=\"epi-flatButton epi-chromelessButton is-active\"\r\n                                data-dojo-props=\"iconClass: 'epi-iconThumbnails', showLabel: false, title: '${resources.switchbuttons.thumbnail}'\">\r\n                        </span>\r\n                    </li>\r\n                </ul>\r\n            </div>\r\n        </div>\r\n    </div>\r\n    <div data-dojo-attach-point=\"gridNode\"></div>\r\n</div>"}});
﻿define("epi-ecf-ui/widget/CatalogContentList", [
// Dojo
    "dojo/_base/array",
    "dojo/aspect",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/window",
    "dojo/keys",
    "dojo/dom-construct",
    "dojo/dom-geometry",
    "dojo/dom-style",
    "dojo/html",
    "dojo/on",
    "dojo/topic",
    "dojo/when",
    "dojo/dom-class",
//Dgrid
    "dgrid/selector",

// EPi Shell
    "epi",
    "epi/shell/dgrid/util/misc",
    "epi/dependency",
    "epi/shell/widget/_FocusableMixin",
    "epi/shell/command/builder/ButtonBuilder",

// EPi CMS
    "epi-cms/core/ContentReference",
    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/dgrid/formatters",
    "epi-cms/widget/_ConfigurableContentListBase",
    "epi-cms/widget/ContentTreeStoreModel",

// commerce
    "./viewmodel/CatalogContentListViewModel",
    "./CommandToolbar",
    "./CommandButton",
    "./MarketSelector",

// Resources
    "dojo/text!./templates/CatalogContentList.html",
    "epi/i18n!epi/cms/nls/commerce.widget.cataloglist",
    "epi/i18n!epi/cms/nls/commerce.widget.catalogcontentlist"
], function (
// Dojo
    array,
    aspect,
    declare,
    lang,
    window,
    keys,
    domConstruct,
    domGeometry,
    domStyle,
    html,
    on,
    topic,
    when,
    domClass,
//Dgrid
    selector,
// EPi Shell
    epi,
    misc,
    dependency,
    _FocusableMixin,
    ButtonBuilder,

// EPi CMS
    ContentReference,
    ContentActionSupport,
    formatters,
    _ConfigurableContentListBase,
    ContentTreeStoreModel,

// commerce
    CatalogContentListViewModel,
    CommandToolbar,
    CommandButton,
    MarketSelector,
// Resources
    template,
    res,
    catalogContentListResources) {

    return declare([_ConfigurableContentListBase, _FocusableMixin], {
        // summary:
        //    Lists the content of catalogs and categories.
        // description:
        //    This is the widget that lists the content of catalogs and categories.
        // tags:
        //    public
        resources: catalogContentListResources,

        templateString: template,

        _multipleSelectionClassName: "epi-dgrid-multiselect--multiple-selection",

        storeKeyName: "epi.cms.content.light",

        _noDataMessage: catalogContentListResources.nodatamessage,

        // contextChangeEvent: [public] String
        //      Setup so that the context change events are not configured in the base class.
        contextChangeEvent: "",

        commandToolbar: null,

        // Shown thumbnails as default
        toggleThumbnail: true,

        postCreate: function () {
            this.inherited(arguments);

            // Watching instead of binding since we need the old value as well
            this.own(
                this.model.clipboardManager.watch("data", lang.hitch(this, function (name, oldValues, newValues) {
                    var isCopy = this.model.clipboardManager.isCopy(),
                        grid = this.grid;

                    var toggleCut = function (items, isCut) {
                        array.forEach(items, function (clip) {
                            var row;
                            if (clip && clip.data) {
                                var rowId = clip.contextId.concat("-", clip.data.contentLink);
                                row = grid.row(rowId);
                                if (row && row.element) {
                                    domClass.toggle(row.element, "epi-opacity50", isCut);
                                }
                            }
                        });
                    };

                    if (oldValues instanceof Array) {
                        toggleCut(oldValues, false);
                    }

                    if (!isCopy && newValues instanceof Array) {
                        toggleCut(newValues, true);
                    }
                }))
            );
        },

        startup: function () {
            // summary:
            //      Adds the breadcrumb widget to the top of the list widget.
            // tags:
            //      protected
            this.inherited(arguments);

            //only the selection column should update selections.
            this.grid.set("selectionMode", "none");

            //making the dragsource handle multiple selects
            this.grid.dndSource.singular = false;

            this.own(
                topic.subscribe("relationChanged", lang.hitch(this, function() {
                    this.grid.refresh();
                })),
                topic.subscribe("catalogContentDeleted", lang.hitch(this, function(deletedItems){
                    when(this.getCurrentContext(), lang.hitch(this, function(currentContext) {
                        var deletedItemIsChildToCurrentContent = array.some(deletedItems, function(item) {
                            return ContentReference.compareIgnoreVersion(currentContext.id, item.data.parentLink);
                        });
                        if (deletedItemIsChildToCurrentContent) {
                            this.grid.clearSelection();
                            this.onDeselectedRow();
                            this.grid.refresh();
                        }
                    }));
                })),
                topic.subscribe("itemPasted", lang.hitch(this, function () {
                    this.grid.refresh();
                }))
            );

            // grid can handle these, no need to "own" them
            this.grid.on("dgrid-rowcopy", lang.hitch(this, this._onRowCopy));
            this.grid.on("dgrid-rowcut", lang.hitch(this, this._onRowCut));
            this.grid.on("dgrid-rowpaste", lang.hitch(this, this._onRowPaste));
            this.grid.addKeyHandler(keys.ENTER, lang.hitch(this, "_onChangeContext"));
            this.grid.addKeyHandler(keys.SPACE, lang.hitch(this, function (evt) {
                var row = this.grid.row(evt);
                if (this.grid.isSelected(row)){
                    this.grid.deselect(row);
                } else {
                    this.grid.select(row);
                }
            }));
        },

        _onRowCopy: function () {
            this.model._commandRegistry.copy.command.execute();
        },

        _onRowCut: function () {
            this.model._commandRegistry.cut.command.execute();
        },

        _onRowPaste: function () {
            this.model._commandRegistry.pasteOnContext.command.execute();
        },

        _onSwitchListView: function () {
            if (this.toggleThumbnail) {
                this._onToggleThumbnail();
            }
        },

        _onSwitchThumbnail: function () {
            if (!this.toggleThumbnail) {
                this._onToggleThumbnail();
            }
        },

        _onToggleThumbnail: function () {
            this.toggleThumbnail = !this.toggleThumbnail;
            domClass.toggle(this.listview.domNode, "is-active");
            domClass.toggle(this.thumbnail.domNode, "is-active");

            domClass.toggle(this.grid.columns.thumbnail, "epi-hide-thumbnail");
            domClass.toggle(this.grid.columns.thumbnail.headerNode, "epi-hide-thumbnail");
            this.grid.refresh();
        },

        buildRendering: function() {
            this.baseClass = "epi-plain-grid epi-dgrid-multiselect";
            this.inherited(arguments);

            var commands = this.model.getSelectionCommands();
            this.commandToolbar = new CommandToolbar(commands);
            this.own(this.commandToolbar);
            domConstruct.place(this.commandToolbar.domNode, this.leadingNode);

            // listen for command toolbar's layout changed, to resize children (grid)
            this.own(aspect.after(this.commandToolbar, "layout", lang.hitch(this, function () {
                this.resize();
            })));
        },

        resize: function () {
            // summary:
            //		Resize this widget to the given dimensions.
            // tags:
            //		protected

            this.inherited(arguments);

            // make the grid 100% height
            if (this.grid) {
                this.grid.resize();
                var top = domGeometry.position(this.grid.domNode).y;
                var bodyHeight = domGeometry.position(window.body()).h;
                domStyle.set(this.grid.domNode, "height", (bodyHeight - top) + "px");
            }
        },

        setupEvents: function(){
            this.inherited(arguments);
            this.own(this.grid.on("dgrid-deselect", lang.hitch(this, this.onDeselectedRow)));
            this.own(this.grid.on(".epi-iconContextMenu:click", lang.hitch(this, this.onContextMenuClick)));

            var mouseup = lang.hitch(this, function (e) {
                this._isColumnDraggable = true;
            }),
            mousedown = lang.hitch(this, function (e) {
                this._isColumnDraggable = false;
            });
            for (var columnName in this.getColumnSettings()) {
                if (columnName === "checkbox") {
                    this.own(
                        // Use _isColumnDraggable to prevent checkbox column from dragging
                        this.grid.on(".dgrid-cell.dgrid-column-" + columnName + ":mousedown", mousedown),
                        // Reset dragging status
                        on(this.grid.domNode, "mouseup", mouseup)
                    );
                    continue;
                }
                this.own(this.grid.on(".dgrid-cell.dgrid-column-" + columnName + ":click", lang.hitch(this, "_onChangeContext")));
            }

            var self = this;
            aspect.around(this.grid.dndSource, "onMouseMove", function (originalMethod) {
                return function (e) {
                    // Cancel dragging if unable to drag
                    if (!self._isColumnDraggable) {
                        return;
                    }

                    return originalMethod.call(self.grid.dndSource, e);
                };
            });

        },

        onDeselectedRow: function(){
            var selection = [];
            for(var id in this.grid.selection){
                var row = this.grid.row(id);
                selection.push(row.data);
            }

            this.model.updateSelection(selection);
            this._removeContextMenuWhenRowIsSelected();
        },

        getListSettings: function () {
            // summary:
            //      Override to specify the settings used to create the list.
            // tags:
            //      protected

            var settings = this.inherited(arguments);

            return lang.mixin(settings, { cellNavigation: false, noDataMessage: this._noDataMessage });
        },

        _onSelect: function () {
            // summary:
            //		Extends _onSelect to remove context menu when multiple rows are selected
            // tags:
            //		protected

            this.inherited(arguments);
            this._removeContextMenuWhenRowIsSelected();
        },

        _removeContextMenuWhenRowIsSelected: function(){
            // summary:
            //		Removes context menu when multiple rows are selected
            // tags:
            //		protected

            domClass.remove(this.grid.contentNode, this._multipleSelectionClassName);

            if (this.model.numSelectedRows > 0) {
                domClass.add(this.grid.contentNode, this._multipleSelectionClassName);
            }
        },

        onContextMenuClick: function(e){
            // we have to update the commands even though we're technically not selecting this row.
            // Selection should only be done in the checkboxes column.
            var row = this.grid.row(e);
            this.model.set("model", { data: [row.data] });

            // Display arrow for menu item whenever have sub menu in context menu
            array.forEach(this.grid.contextMenu.getChildren(), function (menu, i) {
                if (menu.arrowWrapper && menu.popup) {
                    domStyle.set(menu.arrowWrapper, "visibility", "");
                }
            });
            this.grid.clearSelection();
            this.grid.select(row);
        },

        createModel: function () {
            return new CatalogContentListViewModel();
        },

        fetchData: function (context) {
            // summary:
            //		Fetches data by setting a query on the grid. A getrelations query will be performed on the store.
            // tags:
            //		protected

            this._setGridQuery(context.id);

            when(this.store.get(context.id), lang.hitch(this, function (contentData) {
                this.onDeselectedRow();

                var pasteOnContextCommand = this.model._commandRegistry.pasteOnContext.command;
                pasteOnContextCommand.selection.set("data", [{ type: "epi.cms.contentdata", data: contentData }]);
            }));

        },

        _setGridQuery: function(id){
            var queryOptions = { ignore: ["query"], parentId: id, sort: [{ attribute: "typeSortIndex" }] };

            var queryParameters = {
                referenceId: id,
                query: "getchildren",
                market: this.marketSelector.value,
                includeProperties: true,
                allLanguages: true
            };

            this.grid.set("query", queryParameters, queryOptions);
        },

        getColumnSettings: function () {
            // summary:
            //		Returns an object with the settings for the columns of the grid
            // tags:
            //		private
            var self = this;

            return {
                checkbox: selector({
                    label: "",
                    selectorType: "checkbox",
                    className: "epi-columnVeryNarrow"
                }),
                thumbnail: {
                    renderHeaderCell: function (node) {},
                    get: function (object) {
                        return object.properties.thumbnail;
                    },
                    formatter: formatters.thumbnail,
                    sortable: false
                },
                /* Name of column used in sorting - use typeSortIndex property, not typeIdentifier */
                typeSortIndex: {
                    renderHeaderCell: function (node) { },
                    get: function (object) {
                        return object.typeIdentifier;
                    },
                    formatter: formatters.contentIcon,
                    className: "epi-columnIcon16x16"
                },
                name: {
                    label: epi.resources.header.name,
                    className: "epi-columnWide"
                },
                code: {
                    get: function (object) {
                        return object.properties.code;
                    },
                    label: res.code
                },
                price: {
                    get: function (object) {
                        return object.properties.price;
                    },
                    label: res.price,
                    sortable: false
                },
                stock: {
                    get: function (object) {
                        return { count: object.properties.inStockQuantity, status: object.properties.inStockStatus};
                    },
                    label: res.stock,
                    formatter: this._getStockElement,
                    sortable: false
                },
                isPendingPublish: {
                    get: function (object) {
                        return object.status === ContentActionSupport.versionStatus.Published;
                    },
                    label: res.active,
                    formatter: formatters.friendlyBoolean,
                    className: "epi-columnNarrow"
                },
                startPublish: {
                    get: function (object) {
                        return object.properties.startPublish;
                    },
                    label: res.availablefrom,
                    formatter: this._localizedDateAndSecondaryText
                },
                stopPublish: {
                    get: function (object) {
                        return object.properties.stopPublish;
                    },
                    label: epi.resources.header.expires,
                    formatter: this._localizedDateAndSecondaryText
                },
                metaClassName: {
                    get: function (object) {
                        return object.properties.metaClassName;
                    },
                    label: res.producttype,
                    formatter: formatters.secondaryText
                }
            };
        },

        _getStockElement: function (stock) {
            if (stock.count === undefined || stock.count === null) {
                return "";
            }

            var stateCssClass = "epi-stock-" + stock.status;

            return '<span class="epi-stock ' + stateCssClass + '">' + stock.count + misc.icon('epi-iconBoxes') + '</span>';
        },

        _localizedDateAndSecondaryText: function (value) {
            return formatters.secondaryText(formatters.localizedDate(value), true);
        },

        _onMarketChanged: function(){
            if(!this.grid) return;
            var queryOptions = this.grid.get("queryOptions");
            if (queryOptions){
                this._setGridQuery(queryOptions.parentId);
            }
        }
    });
});
